
User Interface - Bug #2707

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

menu/simple_sm.p causes an infinite loop where the window flashes and the OS is nearly unusable

09/11/2015 03:30 PM - Greg Shah

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Vadim Gindin % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: GUI Support for a Complex ADM2 App   

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to User Interface - Bug #2736: fix GUI menu drawing problems in menu/... Closed

History

#1 - 09/11/2015 03:32 PM - Greg Shah

This can be recreated in the trunk revision 10935 by running the menu/simple_sm.p using the Swing client.  Be prepared to kill the session using

something like the task manager, it can't be killed any other way.  The system is nearly unusable until you can kill the app.

#2 - 09/11/2015 05:01 PM - Constantin Asofiei

This one is fixed in 1811q rev 11003 - it was a NPE in FontManager.getTextWidth.

#3 - 09/13/2015 08:39 AM - Greg Shah

This still occurs for me on 1811q revision 11008.  You don't see it?  Could there be a change on your system that is not committed into the branch?

#4 - 09/14/2015 10:32 AM - Constantin Asofiei

I was using a modified version of simple_sm.p, the root cause is this:

java.lang.reflect.InvocationTargetException

    at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)

    at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57)

    at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)

    at java.lang.reflect.Method.invoke(Method.java:606)

    at com.goldencode.p2j.util.MethodInvoker.invoke(MethodInvoker.java:76)

    at com.goldencode.p2j.net.Dispatcher.processInbound(Dispatcher.java:694)

    at com.goldencode.p2j.net.Conversation.block(Conversation.java:319)

    at com.goldencode.p2j.net.Conversation.waitMessage(Conversation.java:257)

    at com.goldencode.p2j.net.Queue.transactImpl(Queue.java:1128)

    at com.goldencode.p2j.net.Queue.transact(Queue.java:585)

    at com.goldencode.p2j.net.BaseSession.transact(BaseSession.java:223)

    at com.goldencode.p2j.net.HighLevelObject.transact(HighLevelObject.java:163)

    at com.goldencode.p2j.net.RemoteObject$RemoteAccess.invokeCore(RemoteObject.java:1425)

    at com.goldencode.p2j.net.InvocationStub.invoke(InvocationStub.java:97)

    at com.sun.proxy.$Proxy4.standardEntry(Unknown Source)

    at com.goldencode.p2j.main.ClientCore.start(ClientCore.java:277)

    at com.goldencode.p2j.main.ClientCore.start(ClientCore.java:100)

    at com.goldencode.p2j.main.ClientDriver.start(ClientDriver.java:201)

    at com.goldencode.p2j.main.CommonDriver.process(CommonDriver.java:398)

    at com.goldencode.p2j.main.ClientDriver.process(ClientDriver.java:1)

    at com.goldencode.p2j.main.ClientDriver.main(ClientDriver.java:267)

Caused by: java.lang.StringIndexOutOfBoundsException: String index out of range: 0

    at java.lang.String.charAt(String.java:658)

    at com.goldencode.p2j.ui.client.MenuItem$Label.init(MenuItem.java:403)

    at com.goldencode.p2j.ui.client.gui.MenuItemGuiImpl$GuiLabel.init(MenuItemGuiImpl.java:683)

04/24/2024 1/4



    at com.goldencode.p2j.ui.client.MenuItem.afterConfigUpdate(MenuItem.java:123)

    at com.goldencode.p2j.ui.client.MenuItem.afterConfigUpdate(MenuItem.java:1)

    at com.goldencode.p2j.ui.ConfigSyncManager.markScopeEnd(ConfigSyncManager.java:247)

    at com.goldencode.p2j.ui.ConfigManager.syncConfigChanges(ConfigManager.java:497)

    at com.goldencode.p2j.ui.ConfigManager.replaceConfig(ConfigManager.java:365)

    at com.goldencode.p2j.ui.client.MenuItem.initialize(MenuItem.java:69)

    at com.goldencode.p2j.ui.client.gui.MenuItemGuiImpl.initialize(MenuItemGuiImpl.java:186)

    at com.goldencode.p2j.ui.client.MenuItem.initialize(MenuItem.java:1)

    at com.goldencode.p2j.ui.client.WidgetRegistry.reconstructWidget(WidgetRegistry.java:126)

    at com.goldencode.p2j.ui.client.WidgetRegistry.pushMenuDescription(WidgetRegistry.java:425)

    at com.goldencode.p2j.ui.chui.ThinClient$18.run(ThinClient.java:7195)

    at com.goldencode.p2j.ui.chui.ThinClient.eventBracket(ThinClient.java:13510)

    at com.goldencode.p2j.ui.chui.ThinClient.eventDrawingBracket(ThinClient.java:13459)

    at com.goldencode.p2j.ui.chui.ThinClient.pushMenuDescription(ThinClient.java:7190)

    ... 21 more

#5 - 09/21/2015 05:10 PM - Greg Shah

Vadim: could you look at this?

It looks like this problem can occur when the MenuItem.Label.init() is passed the empty string:

         this.prepLabel = result.toString();

         if (!mnemonicAssigned)

         {

            this.mnemonic = this.prepLabel.charAt(0);

            this.mnemIdx = 0;

         }

 

Is the empty string a valid case?

If so, then how does the 4GL handle the mnemonic in that case?

#6 - 09/23/2015 11:37 AM - Vadim Gindin

Greg Shah wrote:
Vadim: could you look at this?

It looks like this problem can occur when the MenuItem.Label.init() is passed the empty string:

[...]

Is the empty string a valid case?

If so, then how does the 4GL handle the mnemonic in that case?

 

Theoretically prepLabel can be empty. I'm testing this case, but I've checked simple_sm.p - it works and doesn't contain the cases when prepLabel

can be empty.

#7 - 09/23/2015 12:04 PM - Greg Shah

Constantin reported that it was working too, but he found that his version was modified from the one in testcases/uast/menu/.  On my system, with

1811q (or the p2J trunk), the testcases/uast/menu/simple_sm.p will fail.

#8 - 09/23/2015 02:26 PM - Greg Shah

Have you been able to recreate this issue?

#9 - 09/23/2015 02:32 PM - Vadim Gindin

Greg Shah wrote:

Have you been able to recreate this issue?

 

Well, yes I've added menu-items with empty label and label="&" (that ampersand will be removed during preprocessing) and got described NPE. I've

fixed it and a small drawing bug (CHUI): when menu-item has focus: mnemonic character is displayed without UNDERLINE, but if

mi.hasFocus()==false, than UNDERLINE is used.

I did it in my branch 2707a. I've checked out 1811q just now and I'm going to move my changes there, test it and commit. OK?

#10 - 09/23/2015 03:01 PM - Greg Shah

I'm going to move my changes there, test it and commit.
Yes, please do.

#11 - 09/23/2015 03:15 PM - Vadim Gindin

fix NPE, fix small drawing menu bug for CHUI: mnemonic for the focused menu-item is displayed without underline, fix NPE in menu GUI impls.

Committed in revision 11037 of the branch 1811q.

By the way I've found, that menu GUI drawing is broken. Branch 1811q - run simple_sm.p open the second sub-menu and move mouse pointer to it's

body and than out of it: you will see, that menu background around the body is drawn as menubar background. There is also some blinking, when

moving mouse in the sub-menu body between different menu-items.

#12 - 09/23/2015 03:37 PM - Greg Shah

- Status changed from New to Closed

#13 - 11/10/2015 04:56 AM - Greg Shah

- % Done changed from 0 to 100

- Assignee set to Vadim Gindin

#14 - 11/16/2016 12:13 PM - Greg Shah

- Target version changed from Milestone 12 to GUI Support for a Complex ADM2 App
